public class PointTest {

        static void swap(Point p1, Point p2)        // Java uses pass-by-value
	{
		//Point p = p1;
		//p1 = p2;
		//p2 = p;

		int x = p1.getX(); // T t = p
		int y = p1.getY();
		p1.setX(p2.getX());	// p = q
		p1.setY(p2.getY());
		p2.setX(x);		// q = p
		p2.setY(y);
        }

        public static void main(String[] args)
        {
		Point p1 = new Point();
		System.out.println("p1: " + p1);
		Point p2 = new Point();
		System.out.println("p2: " + p2);
		Point3D p3 = new Point3D();
		System.out.println("p3: " + p3);
		Point3D p4 = new Point3D();
		System.out.println("p4: " + p4);

		p1.setPosition(10, 10);		//   
	        System.out.print("p1 SetPosition: ");
	        p1.print();			//  ǥ 
	        p1.move(20, 50);		// ǥ  ( ġ ̵)
	        System.out.print("p1 Move: ");
	        p1.print();			//  ǥ 

	        p2.setPosition(20, 30); 	//   
	        System.out.print("p2 SetPosition: ");
	        p2.print();			//  ǥ 

	        System.out.printf("p1.X=%d, p1.Y=%d, Point.getCount()=%d, Point.count=%d\n", p1.getX(), p1.getY(), Point.getCount(), Point.count);
	        System.out.printf("p2.X=%d, p2.Y=%d, Point.getCount()=%d\n", p2.getX(), p2.getY(), Point.getCount());

		System.out.println("Before swap p1: " + p1 + " p2 " + p2);
		swap(p1, p2);
		System.out.println("After swap p1: " + p1 + " p2 " + p2);

		// Point3D
	        p3.setPosition(30, 40, 50);
	        System.out.print("p3 SetPosition: ");
	        p3.print();			//  ǥ 
	        p3.move (20, 30, 40);   	// ǥ  ( ġ ̵)
	        System.out.print("p3 Move: ");
	        p3.print();			//  ǥ 
		System.out.printf("Point.getCount()=%d Point.count=%d\n", Point.getCount(), Point.count);

	        p4.setPosition(100, 200, 300);
		System.out.print("p4 SetPosition: ");
		p4.print();			//  ǥ 
		p4.move(10, 10, 10);   // ǥ  ( ġ ̵)
		System.out.print("p4 Move: ");
		p4.print();			//  ǥ 

		System.out.printf("p3.X=%d, p3.Y=%d, p3.Z=%d, Point.getCount()=%d, Point.count=%d\n", p3.getX(), p3.getY(), p3.getZ(), Point.getCount(), Point.count);
		System.out.printf("p4.X=%d, p4.Y=%d, p4.Z=%d, Point.count=%d\n", p4.getX(), p4.getY(), p4.getZ(), Point.count);

		if (p3.equals(p4))
			System.out.println("p3 == p4");
		else
			System.out.println("p3 != p4");

		System.out.print("p5: ");
		Point3D p5 = new Point3D(50, 70, 90);
		p5.print();			//  ǥ 
		if (p5.equals(p3))
			System.out.println("p5 == p3");
		if (p5.equals(p4))
			System.out.println("p5 == p4");
        }
}
